#ifndef NAMED_COUNTER_DATA_ITERATOR_IMPL_INCLUDED__
#define NAMED_COUNTER_DATA_ITERATOR_IMPL_INCLUDED__

#include "NamedCounterFactory.h"

#include "AssociatedPOA.h"

#include "refcount.h"

class NamedCounterDataIteratorImpl : 
   public virtual POA_NamedCounterDataIterator,
	public virtual PortableServer::RefCountServantBase,
   public AssociatedPOA<NamedCounterDataIteratorImpl>
{
	public:
		
      NamedCounterDataIteratorImpl(
         NamedCounterFactoryImpl::CounterContainer &counters);
      
      virtual ~NamedCounterDataIteratorImpl();

      CORBA::Boolean next_n(
         CORBA::ULong how_many, 
		   counterDataSeq_out theCounters);
	
	   void destroy();
		
      bool AtEnd();

   private :

      PortableServer::ObjectId_var m_oid;

      NamedCounterFactoryImpl::CounterContainer &m_counters;
      NamedCounterFactoryImpl::CounterContainer::list_iterator m_current;
};


#endif // NAMED_COUNTER_DATA_ITERATOR_IMPL_INCLUDED__